searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `Yex`.","ref":"Yex.html","title":"Yex","type":"module"},{"doc":"Apply a document update on the shared document.","ref":"Yex.html#apply_update/2","title":"Yex.apply_update/2","type":"function"},{"doc":"iex> doc1 = Yex.Doc.new()\n    iex> doc2 = Yex.Doc.new()\n    iex> {:ok, state1} = Yex.encode_state_as_update(doc1)\n    iex> {:ok, state2} = Yex.encode_state_as_update(doc2)\n    iex> Yex.apply_update(doc1, state2)\n    :ok\n    iex> Yex.apply_update(doc2, state1)\n    :ok","ref":"Yex.html#apply_update/2-examples-sync-two-clients-by-exchanging-the-complete-document-structure","title":"Examples Sync two clients by exchanging the complete document structure - Yex.apply_update/2","type":"function"},{"doc":"","ref":"Yex.html#apply_update_v1/2","title":"Yex.apply_update_v1/2","type":"function"},{"doc":"","ref":"Yex.html#apply_update_v2/2","title":"Yex.apply_update_v2/2","type":"function"},{"doc":"Encode the document state as a single update message that can be applied on the remote document. Optionally, specify the target state vector to only write the missing differences to the update message.","ref":"Yex.html#encode_state_as_update/2","title":"Yex.encode_state_as_update/2","type":"function"},{"doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_as_update(doc)","ref":"Yex.html#encode_state_as_update/2-examples","title":"Examples - Yex.encode_state_as_update/2","type":"function"},{"doc":"","ref":"Yex.html#encode_state_as_update!/2","title":"Yex.encode_state_as_update!/2","type":"function"},{"doc":"","ref":"Yex.html#encode_state_as_update_v1/2","title":"Yex.encode_state_as_update_v1/2","type":"function"},{"doc":"","ref":"Yex.html#encode_state_as_update_v2/2","title":"Yex.encode_state_as_update_v2/2","type":"function"},{"doc":"Computes the state vector and encodes it into an Uint8Array. A state vector describes the state of the local client. The remote client can use this to exchange only the missing differences.","ref":"Yex.html#encode_state_vector/1","title":"Yex.encode_state_vector/1","type":"function"},{"doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_vector(doc)","ref":"Yex.html#encode_state_vector/1-examples","title":"Examples - Yex.encode_state_vector/1","type":"function"},{"doc":"","ref":"Yex.html#encode_state_vector!/1","title":"Yex.encode_state_vector!/1","type":"function"},{"doc":"","ref":"Yex.html#encode_state_vector_v1/1","title":"Yex.encode_state_vector_v1/1","type":"function"},{"doc":"","ref":"Yex.html#encode_state_vector_v2/1","title":"Yex.encode_state_vector_v2/1","type":"function"},{"doc":"A shareable Array-like type that supports efficient insert/delete of elements at any position.","ref":"Yex.Array.html","title":"Yex.Array","type":"module"},{"doc":"","ref":"Yex.Array.html#delete/2","title":"Yex.Array.delete/2","type":"function"},{"doc":"","ref":"Yex.Array.html#delete_range/3","title":"Yex.Array.delete_range/3","type":"function"},{"doc":"","ref":"Yex.Array.html#get/2","title":"Yex.Array.get/2","type":"function"},{"doc":"","ref":"Yex.Array.html#insert/3","title":"Yex.Array.insert/3","type":"function"},{"doc":"","ref":"Yex.Array.html#length/1","title":"Yex.Array.length/1","type":"function"},{"doc":"","ref":"Yex.Array.html#push/2","title":"Yex.Array.push/2","type":"function"},{"doc":"","ref":"Yex.Array.html#to_json/1","title":"Yex.Array.to_json/1","type":"function"},{"doc":"","ref":"Yex.Array.html#to_list/1","title":"Yex.Array.to_list/1","type":"function"},{"doc":"","ref":"Yex.Array.html#unshift/2","title":"Yex.Array.unshift/2","type":"function"},{"doc":"","ref":"Yex.Array.html#t:t/0","title":"Yex.Array.t/0","type":"type"},{"doc":"A preliminary array. It can be used to early initialize the contents of a Array.","ref":"Yex.ArrayPrelim.html","title":"Yex.ArrayPrelim","type":"module"},{"doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> {:ok, %Yex.Array{} = array} = Yex.Map.get(map, \"key\")\n    iex> Yex.Array.get(array, 1)\n    {:ok, \"World\"}","ref":"Yex.ArrayPrelim.html#module-examples","title":"Examples - Yex.ArrayPrelim","type":"module"},{"doc":"","ref":"Yex.ArrayPrelim.html#from/1","title":"Yex.ArrayPrelim.from/1","type":"function"},{"doc":"","ref":"Yex.Doc.html","title":"Yex.Doc","type":"module"},{"doc":"","ref":"Yex.Doc.html#demonitor_update/1","title":"Yex.Doc.demonitor_update/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#demonitor_update_v1/1","title":"Yex.Doc.demonitor_update_v1/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#demonitor_update_v2/1","title":"Yex.Doc.demonitor_update_v2/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#get_array/2","title":"Yex.Doc.get_array/2","type":"function"},{"doc":"","ref":"Yex.Doc.html#get_map/2","title":"Yex.Doc.get_map/2","type":"function"},{"doc":"","ref":"Yex.Doc.html#get_text/2","title":"Yex.Doc.get_text/2","type":"function"},{"doc":"","ref":"Yex.Doc.html#get_xml_fragment/2","title":"Yex.Doc.get_xml_fragment/2","type":"function"},{"doc":"","ref":"Yex.Doc.html#monitor_update/1","title":"Yex.Doc.monitor_update/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#monitor_update_v1/1","title":"Yex.Doc.monitor_update_v1/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#monitor_update_v2/1","title":"Yex.Doc.monitor_update_v2/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#new/0","title":"Yex.Doc.new/0","type":"function"},{"doc":"","ref":"Yex.Doc.html#transaction/2","title":"Yex.Doc.transaction/2","type":"function"},{"doc":"","ref":"Yex.Doc.html#transaction/3","title":"Yex.Doc.transaction/3","type":"function"},{"doc":"","ref":"Yex.Doc.html#with_options/1","title":"Yex.Doc.with_options/1","type":"function"},{"doc":"","ref":"Yex.Doc.html#t:t/0","title":"Yex.Doc.t/0","type":"type"},{"doc":"Document options.","ref":"Yex.Doc.Options.html","title":"Yex.Doc.Options","type":"module"},{"doc":"A shareable Map type.","ref":"Yex.Map.html","title":"Yex.Map","type":"module"},{"doc":"","ref":"Yex.Map.html#delete/2","title":"Yex.Map.delete/2","type":"function"},{"doc":"","ref":"Yex.Map.html#get/2","title":"Yex.Map.get/2","type":"function"},{"doc":"","ref":"Yex.Map.html#set/3","title":"Yex.Map.set/3","type":"function"},{"doc":"","ref":"Yex.Map.html#size/1","title":"Yex.Map.size/1","type":"function"},{"doc":"","ref":"Yex.Map.html#to_json/1","title":"Yex.Map.to_json/1","type":"function"},{"doc":"","ref":"Yex.Map.html#to_map/1","title":"Yex.Map.to_map/1","type":"function"},{"doc":"","ref":"Yex.Map.html#t:t/0","title":"Yex.Map.t/0","type":"type"},{"doc":"A preliminary map. It can be used to early initialize the contents of a Map.","ref":"Yex.MapPrelim.html","title":"Yex.MapPrelim","type":"module"},{"doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert(array, 0, Yex.MapPrelim.from(%{ \"key\" => \"value\" }))\n    iex> {:ok, %Yex.Map{} = map} = Yex.Array.get(array, 0)\n    iex> Yex.Map.get(map, \"key\")\n    {:ok, \"value\"}","ref":"Yex.MapPrelim.html#module-examples","title":"Examples - Yex.MapPrelim","type":"module"},{"doc":"","ref":"Yex.MapPrelim.html#from/1","title":"Yex.MapPrelim.from/1","type":"function"},{"doc":"A shareable type that is optimized for shared editing on text.","ref":"Yex.Text.html","title":"Yex.Text","type":"module"},{"doc":"","ref":"Yex.Text.html#apply_delta/2","title":"Yex.Text.apply_delta/2","type":"function"},{"doc":"","ref":"Yex.Text.html#delete/3","title":"Yex.Text.delete/3","type":"function"},{"doc":"","ref":"Yex.Text.html#format/4","title":"Yex.Text.format/4","type":"function"},{"doc":"","ref":"Yex.Text.html#insert/3","title":"Yex.Text.insert/3","type":"function"},{"doc":"","ref":"Yex.Text.html#insert/4","title":"Yex.Text.insert/4","type":"function"},{"doc":"","ref":"Yex.Text.html#length/1","title":"Yex.Text.length/1","type":"function"},{"doc":"","ref":"Yex.Text.html#to_json/1","title":"Yex.Text.to_json/1","type":"function"},{"doc":"","ref":"Yex.Text.html#to_string/1","title":"Yex.Text.to_string/1","type":"function"},{"doc":"","ref":"Yex.Text.html#t:t/0","title":"Yex.Text.t/0","type":"type"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}